Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4723)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4724)
@@ -1178,176 +1639,347 @@
        ENDIF
 
-       IF ( bc_dirichlet_s )  THEN
-
-          DO  i = nxl, nxr
-             DO  k = nzb+1, nzt
-                v(k,0,i) = interpolate_in_time( nest_offl%v_south(0,k,i),      &
-                                                nest_offl%v_south(1,k,i),      &
-                                                fac_dt ) *                     &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_total_0(k,0,i), 2 ) )
-                v(k,-1,i) = v(k,0,i) 
-             ENDDO
-             v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,0,i)
-          ENDDO
-
-          DO  i = nxl, nxr
-             DO  k = nzb+1, nzt-1
-                w(k,-1,i) = interpolate_in_time( nest_offl%w_south(0,k,i),     &
-                                                 nest_offl%w_south(1,k,i),     &
-                                                 fac_dt ) *                    &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_total_0(k,-1,i), 3 ) )
-             ENDDO
-             w(nzt,-1,i) = w(nzt-1,-1,i)
-          ENDDO
-
-          DO  i = nxlu, nxr
-             DO  k = nzb+1, nzt
-                u(k,-1,i) = interpolate_in_time( nest_offl%u_south(0,k,i),     &
-                                                 nest_offl%u_south(1,k,i),     &
-                                                 fac_dt ) *                    &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_total_0(k,-1,i), 1 ) )
-             ENDDO
-             u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,-1,i)
-          ENDDO
-
-          IF ( .NOT. neutral )  THEN
+       IF ( bc_dirichlet_n )  THEN
+!
+!--       v-component
+          IF ( lod == 2 )  THEN
              DO  i = nxl, nxr
                 DO  k = nzb+1, nzt
-                   pt(k,-1,i) = interpolate_in_time(                           &
-                                                 nest_offl%pt_south(0,k,i),    &
-                                                 nest_offl%pt_south(1,k,i),    &
+                   v(k,j_bound_v,i) = interpolate_in_time( nest_offl%v_n(0,k,i),                   &
+                                                           nest_offl%v_n(1,k,i),                   &
+                                                           fac_dt ) *                              &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(k,j_bound_v,i), 2 ) )
+                ENDDO
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j_bound_v,i)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%v_n(0,k,1),                             &
+                                                 nest_offl%v_n(1,k,1),                             &
                                                  fac_dt )
- 
-                ENDDO
-                pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,-1,i)
-             ENDDO
-          ENDIF
-
+             ENDDO
+             DO  i = nxl, nxr
+                v(nzb+1:nzt,j_bound_v,i) = var_1d(nzb+1:nzt) *                                     &
+                                     MERGE( 1.0_wp, 0.0_wp,                                        &
+                                            BTEST( wall_flags_total_0(nzb+1:nzt,j_bound_v,i), 2 ) )
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j_bound_v,i)
+             ENDDO
+          ENDIF
+!
+!--       w-component
+          IF ( lod == 2 )  THEN
+             DO  i = nxl, nxr
+                DO  k = nzb+1, nzt-1
+                   w(k,j_bound,i) = interpolate_in_time( nest_offl%w_n(0,k,i),                     &
+                                                         nest_offl%w_n(1,k,i),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j_bound,i), 3 ) )
+                ENDDO
+                w(nzt,j_bound,i) = w(nzt-1,j_bound,i)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt-1
+                var_1d(k) = interpolate_in_time( nest_offl%w_n(0,k,1),                             &
+                                                 nest_offl%w_n(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  i = nxl, nxr
+                w(nzb+1:nzt-1,j_bound,i) = var_1d(nzb+1:nzt-1) *                                   &
+                                     MERGE( 1.0_wp, 0.0_wp,                                        &
+                                            BTEST( wall_flags_total_0(nzb+1:nzt-1,j_bound,i), 3 ) )
+                w(nzt,j_bound,i) = w(nzt-1,j_bound,i)
+             ENDDO
+          ENDIF
+!
+!--       u-component
+          IF ( lod == 2 )  THEN
+             DO  i = nxlu, nxr
+                DO  k = nzb+1, nzt
+                   u(k,j_bound,i) = interpolate_in_time( nest_offl%u_n(0,k,i),                     &
+                                                         nest_offl%u_n(1,k,i),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j_bound,i), 1 ) )
+                ENDDO
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j_bound,i)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%u_n(0,k,1),                             &
+                                                 nest_offl%u_n(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  i = nxlu, nxr
+                u(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt) *                                       &
+                                       MERGE( 1.0_wp, 0.0_wp,                                      &
+                                              BTEST( wall_flags_total_0(nzb+1:nzt,j_bound,i), 1 ) )
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j_bound,i)
+             ENDDO
+          ENDIF
+!
+!--       potential temperature
+          IF ( .NOT. neutral )  THEN
+             IF ( lod == 2 )  THEN
+                DO  i = nxl, nxr
+                   DO  k = nzb+1, nzt
+                      pt(k,j_bound,i) = interpolate_in_time( nest_offl%pt_n(0,k,i),                &
+                                                             nest_offl%pt_n(1,k,i),                &
+                                                             fac_dt )
+                   ENDDO
+                   pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ELSE
+                DO  k = nzb+1, nzt
+                   var_1d(k) = interpolate_in_time( nest_offl%pt_n(0,k,1),                         &
+                                                    nest_offl%pt_n(1,k,1),                         &
+                                                    fac_dt )
+                ENDDO
+                DO  i = nxl, nxr
+                   pt(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt)
+                   pt_ref_l(nzb+1:nzt)     = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       humidity
           IF ( humidity )  THEN
+             IF ( lod == 2 )  THEN
+                DO  i = nxl, nxr
+                   DO  k = nzb+1, nzt
+                      q(k,j_bound,i) = interpolate_in_time( nest_offl%q_n(0,k,i),                  &
+                                                            nest_offl%q_n(1,k,i),                  &
+                                                            fac_dt )
+                   ENDDO
+                   q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ELSE
+                DO  k = nzb+1, nzt
+                   var_1d(k) = interpolate_in_time( nest_offl%q_n(0,k,1),                          &
+                                                    nest_offl%q_n(1,k,1),                          &
+                                                    fac_dt )
+                ENDDO
+                DO  i = nxl, nxr
+                   q(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt)
+                   q_ref_l(nzb+1:nzt)     = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       chemistry
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND( chem_species, 1 )
+                IF ( nest_offl%chem_from_file_n(n) )  THEN
+                   IF ( lod == 2 )  THEN
+                      DO  i = nxl, nxr
+                         DO  k = nzb+1, nzt
+                            chem_species(n)%conc(k,j_bound,i) = interpolate_in_time(               &
+                                                                        nest_offl%chem_n(0,k,i,n), &
+                                                                        nest_offl%chem_n(1,k,i,n), &
+                                                                        fac_dt                    )
+                         ENDDO
+                         ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)                         &
+                                          + chem_species(n)%conc(nzb+1:nzt,j_bound,i)
+                      ENDDO
+                   ELSE
+                      DO  k = nzb+1, nzt
+                         var_1d(k) = interpolate_in_time( nest_offl%chem_n(0,k,1,n),               &
+                                                          nest_offl%chem_n(1,k,1,n),               &
+                                                          fac_dt )
+                      ENDDO
+                      DO  i = nxl, nxr
+                         chem_species(n)%conc(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt)
+                         ref_chem_l(nzb+1:nzt,n)                   = ref_chem_l(nzb+1:nzt,n) +     &
+                                                                     chem_species(n)%conc(nzb+1:nzt,j_bound,i)
+                      ENDDO
+                   ENDIF
+                ENDIF
+             ENDDO
+          ENDIF
+       ENDIF
+
+       IF ( bc_dirichlet_s )  THEN
+!
+!--       v-component
+          IF ( lod == 2 )  THEN
              DO  i = nxl, nxr
                 DO  k = nzb+1, nzt
-                   q(k,-1,i) = interpolate_in_time(                            &
-                                                 nest_offl%q_south(0,k,i),     &
-                                                 nest_offl%q_south(1,k,i),     &
+                   v(k,j_bound_v,i) = interpolate_in_time( nest_offl%v_s(0,k,i),                   &
+                                                           nest_offl%v_s(1,k,i),                   &
+                                                           fac_dt ) *                              &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(k,j_bound_v,i), 2 ) )
+                ENDDO
+                v(:,j_bound_v-1,i) = v(:,j_bound_v,i) 
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j_bound_v,i)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%v_s(0,k,1),                             &
+                                                 nest_offl%v_s(1,k,1),                             &
                                                  fac_dt )
- 
-                ENDDO
-                q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,-1,i)
-             ENDDO
-          ENDIF
-
+             ENDDO
+             DO  i = nxl, nxr
+                v(nzb+1:nzt,j_bound_v,i) = var_1d(nzb+1:nzt) *                                     &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzb+1:nzt,j_bound_v,i), 2 ) )
+                v(:,j_bound_v-1,i) = v(:,j_bound_v,i) 
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j_bound_v,i)
+             ENDDO
+          ENDIF
+!
+!--       w-component
+          IF ( lod == 2 )  THEN
+             DO  i = nxl, nxr
+                DO  k = nzb+1, nzt-1
+                   w(k,j_bound,i) = interpolate_in_time( nest_offl%w_s(0,k,i),                     &
+                                                         nest_offl%w_s(1,k,i),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j_bound,i), 3 ) )
+                ENDDO
+                w(nzt,j_bound,i) = w(nzt-1,j_bound,i)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt-1
+                var_1d(k) = interpolate_in_time( nest_offl%w_s(0,k,1),                             &
+                                                 nest_offl%w_s(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  i = nxl, nxr
+                w(nzb+1:nzt-1,j_bound,i) = var_1d(nzb+1:nzt-1) *                                   &
+                                     MERGE( 1.0_wp, 0.0_wp,                                        &
+                                            BTEST( wall_flags_total_0(nzb+1:nzt-1,j_bound,i), 3 ) )
+                w(nzt,j_bound,i) = w(nzt-1,j_bound,i)
+             ENDDO
+          ENDIF
+!
+!--       u-component
+          IF ( lod == 2 )  THEN
+             DO  i = nxlu, nxr
+                DO  k = nzb+1, nzt
+                   u(k,j_bound,i) = interpolate_in_time( nest_offl%u_s(0,k,i),                     &
+                                                         nest_offl%u_s(1,k,i),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j_bound,i), 1 ) )
+                ENDDO
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j_bound,i)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%u_s(0,k,1),                             &
+                                                 nest_offl%u_s(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  i = nxlu, nxr
+                u(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt) *                                       &
+                                       MERGE( 1.0_wp, 0.0_wp,                                      &
+                                              BTEST( wall_flags_total_0(nzb+1:nzt,j_bound,i), 1 ) )
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j_bound,i)
+             ENDDO
+          ENDIF
+!
+!--       potential temperature
+          IF ( .NOT. neutral )  THEN
+             IF ( lod == 2 )  THEN
+                DO  i = nxl, nxr
+                   DO  k = nzb+1, nzt
+                      pt(k,j_bound,i) = interpolate_in_time( nest_offl%pt_s(0,k,i),                &
+                                                             nest_offl%pt_s(1,k,i),                &
+                                                             fac_dt )
+                   ENDDO
+                   pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ELSE
+                DO  k = nzb+1, nzt
+                   var_1d(k) = interpolate_in_time( nest_offl%pt_s(0,k,1),                         &
+                                                    nest_offl%pt_s(1,k,1),                         &
+                                                    fac_dt )
+                ENDDO
+                DO  i = nxl, nxr
+                   pt(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt)
+                   pt_ref_l(nzb+1:nzt)     = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       humidity
+          IF ( humidity )  THEN
+             IF ( lod == 2 )  THEN
+                DO  i = nxl, nxr
+                   DO  k = nzb+1, nzt
+                      q(k,j_bound,i) = interpolate_in_time( nest_offl%q_s(0,k,i),                  &
+                                                            nest_offl%q_s(1,k,i),                  &
+                                                            fac_dt )
+                   ENDDO
+                   q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ELSE
+                DO  k = nzb+1, nzt
+                   var_1d(k) = interpolate_in_time( nest_offl%q_s(0,k,1),                          &
+                                                    nest_offl%q_s(1,k,1),                          &
+                                                    fac_dt )
+                ENDDO
+                DO  i = nxl, nxr
+                   q(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt)
+                   q_ref_l(nzb+1:nzt)     = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j_bound,i)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       chemistry
           IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
              DO  n = 1, UBOUND( chem_species, 1 )
                 IF ( nest_offl%chem_from_file_s(n) )  THEN
-                   DO  i = nxl, nxr
+                   IF ( lod == 2 )  THEN
+                      DO  i = nxl, nxr
+                         DO  k = nzb+1, nzt
+                            chem_species(n)%conc(k,j_bound,i) = interpolate_in_time(               &
+                                                                        nest_offl%chem_s(0,k,i,n), &
+                                                                        nest_offl%chem_s(1,k,i,n), &
+                                                                        fac_dt                    )
+                         ENDDO
+                         ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)                         &
+                                          + chem_species(n)%conc(nzb+1:nzt,j_bound,i)
+                      ENDDO
+                   ELSE
                       DO  k = nzb+1, nzt
-                         chem_species(n)%conc(k,-1,i) = interpolate_in_time(   &
-                                                 nest_offl%chem_south(0,k,i,n),&
-                                                 nest_offl%chem_south(1,k,i,n),&
-                                                 fac_dt                    )
+                         var_1d(k) = interpolate_in_time( nest_offl%chem_s(0,k,1,n),               &
+                                                          nest_offl%chem_s(1,k,1,n),               &
+                                                          fac_dt )
                       ENDDO
-                      ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)        &
-                                       + chem_species(n)%conc(nzb+1:nzt,-1,i)
-                   ENDDO
+                      DO  i = nxl, nxr
+                         chem_species(n)%conc(nzb+1:nzt,j_bound,i) = var_1d(nzb+1:nzt)
+                         ref_chem_l(nzb+1:nzt,n)                   = ref_chem_l(nzb+1:nzt,n) +     &
+                                                                     chem_species(n)%conc(nzb+1:nzt,j_bound,i)
+                      ENDDO
+                   ENDIF
                 ENDIF
              ENDDO
           ENDIF
-
-       ENDIF
-
-       IF ( bc_dirichlet_n )  THEN
-
-          DO  i = nxl, nxr
-             DO  k = nzb+1, nzt
-                v(k,nyn+1,i) = interpolate_in_time( nest_offl%v_north(0,k,i),  &
-                                                    nest_offl%v_north(1,k,i),  &
-                                                    fac_dt ) *                 &
-                               MERGE( 1.0_wp, 0.0_wp,                          &
-                                    BTEST( wall_flags_total_0(k,nyn+1,i), 2 ) )
-             ENDDO
-             v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,nyn+1,i)
+       ENDIF
+!
+!--    Top boundary
+!--    u-component
+       IF ( lod == 2 )  THEN
+          DO  i = nxlu, nxr
+             DO  j = nys, nyn
+                u(nzt+1,j,i) = interpolate_in_time( nest_offl%u_top(0,j,i),                        &
+                                                    nest_offl%u_top(1,j,i),                        &
+                                                    fac_dt ) *                                     &
+                              MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(nzt+1,j,i), 1 ) )
+                u_ref_l(nzt+1) = u_ref_l(nzt+1) + u(nzt+1,j,i)
+             ENDDO
           ENDDO
-          DO  i = nxl, nxr
-             DO  k = nzb+1, nzt-1
-                w(k,nyn+1,i) = interpolate_in_time( nest_offl%w_north(0,k,i),  &
-                                                    nest_offl%w_north(1,k,i),  &
-                                                    fac_dt ) *                 &
-                               MERGE( 1.0_wp, 0.0_wp,                          &
-                                    BTEST( wall_flags_total_0(k,nyn+1,i), 3 ) )
-             ENDDO
-             w(nzt,nyn+1,i) = w(nzt-1,nyn+1,i)
-          ENDDO
-
-          DO  i = nxlu, nxr
-             DO  k = nzb+1, nzt
-                u(k,nyn+1,i) = interpolate_in_time( nest_offl%u_north(0,k,i),  &
-                                                    nest_offl%u_north(1,k,i),  &
-                                                    fac_dt ) *                 &
-                               MERGE( 1.0_wp, 0.0_wp,                          &
-                                    BTEST( wall_flags_total_0(k,nyn+1,i), 1 ) )
-
-             ENDDO
-             u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,nyn+1,i)
-          ENDDO
-
-          IF ( .NOT. neutral )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb+1, nzt
-                   pt(k,nyn+1,i) = interpolate_in_time(                        &
-                                                    nest_offl%pt_north(0,k,i), &
-                                                    nest_offl%pt_north(1,k,i), &
-                                                    fac_dt )
- 
-                ENDDO
-                pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,nyn+1,i)
-             ENDDO
-          ENDIF
-
-          IF ( humidity )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb+1, nzt
-                   q(k,nyn+1,i) = interpolate_in_time(                         &
-                                                    nest_offl%q_north(0,k,i),  &
-                                                    nest_offl%q_north(1,k,i),  &
-                                                    fac_dt )
- 
-                ENDDO
-                q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,nyn+1,i)
-             ENDDO
-          ENDIF
-
-          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-             DO  n = 1, UBOUND( chem_species, 1 )
-                IF ( nest_offl%chem_from_file_n(n) )  THEN
-                   DO  i = nxl, nxr
-                      DO  k = nzb+1, nzt
-                         chem_species(n)%conc(k,nyn+1,i) = interpolate_in_time(&
-                                                 nest_offl%chem_north(0,k,i,n),&
-                                                 nest_offl%chem_north(1,k,i,n),&
-                                                 fac_dt                       )
-                      ENDDO
-                      ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)        &
-                                       + chem_species(n)%conc(nzb+1:nzt,nyn+1,i)
-                   ENDDO
-                ENDIF
-             ENDDO
-          ENDIF
-
-       ENDIF
-!
-!--    Top boundary
-       DO  i = nxlu, nxr
-          DO  j = nys, nyn
-             u(nzt+1,j,i) = interpolate_in_time( nest_offl%u_top(0,j,i),       &
-                                                 nest_offl%u_top(1,j,i),       &
-                                                 fac_dt ) *                    &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_total_0(nzt+1,j,i), 1 ) )
-             u_ref_l(nzt+1) = u_ref_l(nzt+1) + u(nzt+1,j,i)
-          ENDDO
-       ENDDO
+       ELSE
+          var_1d(nzt+1) = interpolate_in_time( nest_offl%u_top(0,1,1),                             &
+                                               nest_offl%u_top(1,1,1),                             &
+                                               fac_dt )
+          u(nzt+1,nys:nyn,nxlu:nxr) = var_1d(nzt+1) *                                              &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzt+1,nys:nyn,nxlu:nxr), 1 ) )
+          u_ref_l(nzt+1) = u_ref_l(nzt+1) + SUM( u(nzt+1,nys:nyn,nxlu:nxr) )
+       ENDIF
 !
 !--    For left boundary set boundary condition for u-component also at top 
@@ -1355,15 +1987,25 @@
 !--    Note, this has no effect on the numeric solution, only for data output.
        IF ( bc_dirichlet_l )  u(nzt+1,:,nxl) = u(nzt+1,:,nxlu)
-
-       DO  i = nxl, nxr
-          DO  j = nysv, nyn
-             v(nzt+1,j,i) = interpolate_in_time( nest_offl%v_top(0,j,i),       &
-                                                 nest_offl%v_top(1,j,i),       &
-                                                 fac_dt ) *                    &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_total_0(nzt+1,j,i), 2 ) )
-             v_ref_l(nzt+1) = v_ref_l(nzt+1) + v(nzt+1,j,i)
+!
+!--    v-component
+       IF ( lod == 2 )  THEN
+          DO  i = nxl, nxr
+             DO  j = nysv, nyn
+                v(nzt+1,j,i) = interpolate_in_time( nest_offl%v_top(0,j,i),                        &
+                                                    nest_offl%v_top(1,j,i),                        &
+                                                    fac_dt ) *                                     &
+                              MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(nzt+1,j,i), 2 ) )
+                v_ref_l(nzt+1) = v_ref_l(nzt+1) + v(nzt+1,j,i)
+             ENDDO
           ENDDO
-       ENDDO
+       ELSE
+          var_1d(nzt+1) = interpolate_in_time( nest_offl%v_top(0,1,1),                             &
+                                               nest_offl%v_top(1,1,1),                             &
+                                               fac_dt )
+          v(nzt+1,nysv:nyn,nxl:nxr) = var_1d(nzt+1) *                                              &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzt+1,nysv:nyn,nxl:nxr), 2 ) )
+          v_ref_l(nzt+1) = v_ref_l(nzt+1) + SUM( v(nzt+1,nysv:nyn,nxl:nxr) )
+       ENDIF
 !
 !--    For south boundary set boundary condition for v-component also at top 
